
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16L
;Program type           : Application
;Clock frequency        : 11.059200 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16L
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _SiRevIntFlag=R5
	.DEF _SiSendFlag=R4

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x6B:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x6D:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x74:
	.DB  0x0,0x0
_0x0:
	.DB  0x53,0x69,0x34,0x34,0x33,0x32,0x5F,0x52
	.DB  0x65,0x61,0x64,0x5F,0x52,0x65,0x67,0x69
	.DB  0x73,0x74,0x65,0x72,0x28,0x30,0x78,0x37
	.DB  0x35,0x29,0x3D,0x25,0x30,0x32,0x78,0xD
	.DB  0xA,0x0,0x53,0x69,0x34,0x34,0x33,0x32
	.DB  0x5F,0x52,0x65,0x61,0x64,0x5F,0x52,0x65
	.DB  0x67,0x69,0x73,0x74,0x65,0x72,0x28,0x30
	.DB  0x78,0x37,0x36,0x29,0x3D,0x25,0x30,0x32
	.DB  0x78,0xD,0xA,0x0,0x53,0x69,0x34,0x34
	.DB  0x33,0x32,0x5F,0x52,0x65,0x61,0x64,0x5F
	.DB  0x52,0x65,0x67,0x69,0x73,0x74,0x65,0x72
	.DB  0x28,0x30,0x78,0x37,0x37,0x29,0x3D,0x25
	.DB  0x30,0x32,0x78,0xD,0xA,0x0,0x73,0x74
	.DB  0x61,0x72,0x74,0x2E,0x2E,0x2E,0xD,0xA
	.DB  0x0
_0x202005F:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x0B
	.DW  _0x6C
	.DW  _0x0*2+102

	.DW  0x02
	.DW  0x04
	.DW  _0x74*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x202005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Date    : 2013-12-20
;Chip type           : ATmega16L
;Clock frequency     : 11.059200 MHz
;LUKE   xiechenglin  13760249474
;QQ:35284316
;E-mail:13760249474@139.com
;*****************************************************/
;#include "main.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 000E {

	.CSEG
_ext_int0_isr:
	ST   -Y,R30
; 0000 000F     GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0010     SiRevIntFlag=1;
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 0011 }
	LD   R30,Y+
	RETI
;
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 0014 {
_usart_rx_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0015     if(SiSendFlag==0)
	TST  R4
	BRNE _0x3
; 0000 0016     {
; 0000 0017 	    RevUartBuf[revCnt++]=UDR;
	LDI  R26,LOW(_revCnt)
	LDI  R27,HIGH(_revCnt)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	SUBI R30,LOW(-_RevUartBuf)
	SBCI R31,HIGH(-_RevUartBuf)
	MOVW R26,R30
	IN   R30,0xC
	ST   X,R30
; 0000 0018 	    if( (RevUartBuf[revCnt-2]==0x0d)&&(RevUartBuf[revCnt-1]==0x0a) )
	CALL SUBOPT_0x0
	__SUBD1N 2
	SUBI R30,LOW(-_RevUartBuf)
	SBCI R31,HIGH(-_RevUartBuf)
	LD   R30,Z
	CPI  R30,LOW(0xD)
	BRNE _0x5
	CALL SUBOPT_0x0
	__SUBD1N 1
	SUBI R30,LOW(-_RevUartBuf)
	SBCI R31,HIGH(-_RevUartBuf)
	LD   R30,Z
	CPI  R30,LOW(0xA)
	BREQ _0x6
_0x5:
	RJMP _0x4
_0x6:
; 0000 0019         {
; 0000 001A             SiSendFlag=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 001B         }
; 0000 001C         if(revCnt>126)revCnt=0;
_0x4:
	LDS  R26,_revCnt
	LDS  R27,_revCnt+1
	LDS  R24,_revCnt+2
	LDS  R25,_revCnt+3
	__CPD2N 0x7F
	BRLO _0x7
	CALL SUBOPT_0x1
; 0000 001D     }
_0x7:
; 0000 001E }
_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;
;
;void Io_Init(void)
; 0000 0023 {
_Io_Init:
; 0000 0024     // Input/Output Ports initialization
; 0000 0025     // Port A initialization
; 0000 0026     // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0027     // State7=T State6=T State5=T State4=P State3=0 State2=0 State1=1 State0=1
; 0000 0028     PORTA=0x13;
	LDI  R30,LOW(19)
	OUT  0x1B,R30
; 0000 0029     DDRA=0x0F;
	LDI  R30,LOW(15)
	OUT  0x1A,R30
; 0000 002A 
; 0000 002B     // Port B initialization
; 0000 002C     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
; 0000 002D     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0
; 0000 002E     PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 002F     DDRB=0x01;
	LDI  R30,LOW(1)
	OUT  0x17,R30
; 0000 0030 
; 0000 0031     // Port C initialization
; 0000 0032     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0033     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0034     PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0035     DDRC=0x00;
	OUT  0x14,R30
; 0000 0036 
; 0000 0037     // Port D initialization
; 0000 0038     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0039     // State7=P State6=T State5=T State4=T State3=T State2=P State1=T State0=T
; 0000 003A     PORTD=0xff;
	LDI  R30,LOW(255)
	OUT  0x12,R30
; 0000 003B     DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 003C }
	RET
;
;void Uart_Init(void)
; 0000 003F {
_Uart_Init:
; 0000 0040     // USART initialization
; 0000 0041     // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0042     // USART Receiver: On
; 0000 0043     // USART Transmitter: On
; 0000 0044     // USART Mode: Asynchronous
; 0000 0045     // USART Baud Rate: 9600 (Double Speed Mode)
; 0000 0046     UCSRA=0x02;
	LDI  R30,LOW(2)
	OUT  0xB,R30
; 0000 0047     UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 0048     UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0049     UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 004A     UBRRL=0x8F;
	LDI  R30,LOW(143)
	OUT  0x9,R30
; 0000 004B }
	RET
;
;
;void Ext_Inter_Init(void)
; 0000 004F {
_Ext_Inter_Init:
; 0000 0050     // External Interrupt(s) initialization
; 0000 0051     // INT0: On
; 0000 0052     // INT0 Mode: Falling Edge
; 0000 0053     // INT1: Off
; 0000 0054     // INT2: Off
; 0000 0055     GICR|=0x40;
	IN   R30,0x3B
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 0056     MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0000 0057     MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0058     GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0059 }
	RET
;
;void UartSendByte(unsigned char ch)
; 0000 005C {
_UartSendByte:
; 0000 005D 	while(!(UCSRA&(1<<5)));
;	ch -> Y+0
_0x8:
	IN   R30,0xB
	LDI  R31,0
	ANDI R30,LOW(0x20)
	BREQ _0x8
; 0000 005E 	UDR=ch;
	LD   R30,Y
	OUT  0xC,R30
; 0000 005F }
	JMP  _0x20A0001
;
;void UartSendStr(unsigned char *str)
; 0000 0062 {
_UartSendStr:
; 0000 0063 	while(*str)
;	*str -> Y+0
_0xB:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0xD
; 0000 0064 	{
; 0000 0065 		UartSendByte(*str++);
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	ST   -Y,R30
	RCALL _UartSendByte
; 0000 0066 	}
	RJMP _0xB
_0xD:
; 0000 0067 }
	ADIW R28,2
	RET
;
;void UartSendBuf(unsigned char *buf,unsigned long bufLength)
; 0000 006A {
_UartSendBuf:
; 0000 006B 	unsigned long i;
; 0000 006C 	for(i=0;i<bufLength;i++)
	SBIW R28,4
;	*buf -> Y+8
;	bufLength -> Y+4
;	i -> Y+0
	__CLRD1S 0
_0xF:
	__GETD1S 4
	__GETD2S 0
	CALL __CPD21
	BRSH _0x10
; 0000 006D 	{
; 0000 006E 		UartSendByte(buf[i]);
	__GETD1S 0
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RCALL _UartSendByte
; 0000 006F 	}
	__GETD1S 0
	__SUBD1N -1
	__PUTD1S 0
	RJMP _0xF
_0x10:
; 0000 0070 }
	ADIW R28,10
	RET
;
;
;void Key_Scan(void)
; 0000 0074 {
_Key_Scan:
; 0000 0075     unsigned char buf[8]={0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
; 0000 0076      if(KEY==0)
	SBIW R28,8
	LDI  R30,LOW(1)
	ST   Y,R30
	LDI  R30,LOW(2)
	STD  Y+1,R30
	LDI  R30,LOW(3)
	STD  Y+2,R30
	LDI  R30,LOW(4)
	STD  Y+3,R30
	LDI  R30,LOW(5)
	STD  Y+4,R30
	LDI  R30,LOW(6)
	STD  Y+5,R30
	LDI  R30,LOW(7)
	STD  Y+6,R30
	LDI  R30,LOW(8)
	STD  Y+7,R30
;	buf -> Y+0
	SBIC 0x10,7
	RJMP _0x11
; 0000 0077      {
; 0000 0078         delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x2
; 0000 0079         if(KEY==0)
	SBIC 0x10,7
	RJMP _0x12
; 0000 007A         {
; 0000 007B             while(KEY==0);
_0x13:
	SBIS 0x10,7
	RJMP _0x13
; 0000 007C             LED=~LED;
	SBIS 0x18,0
	RJMP _0x16
	CBI  0x18,0
	RJMP _0x17
_0x16:
	SBI  0x18,0
_0x17:
; 0000 007D             Si4432_Send_Data(buf,sizeof(buf));
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _Si4432_Send_Data
; 0000 007E         }
; 0000 007F      }
_0x12:
; 0000 0080 }
_0x11:
	ADIW R28,8
	RET
;
;
;
;
;void Si4432_Write_Register(unsigned char regAddr,unsigned char regVol)
; 0000 0086 {
_Si4432_Write_Register:
; 0000 0087     unsigned char i;
; 0000 0088     regAddr|=0x80;
	ST   -Y,R17
;	regAddr -> Y+2
;	regVol -> Y+1
;	i -> R17
	CALL SUBOPT_0x3
	ORI  R30,0x80
	CALL SUBOPT_0x4
; 0000 0089 
; 0000 008A     SI_NSEL=0;
; 0000 008B     delay_us(2);
; 0000 008C     for(i=0;i<8;i++)
_0x1B:
	CPI  R17,8
	BRSH _0x1C
; 0000 008D     {
; 0000 008E         if(regAddr&0x80)
	CALL SUBOPT_0x3
	ANDI R30,LOW(0x80)
	BREQ _0x1D
; 0000 008F         {
; 0000 0090             SI_SDO=1;
	SBI  0x1B,3
; 0000 0091         }
; 0000 0092         else
	RJMP _0x20
_0x1D:
; 0000 0093         {
; 0000 0094             SI_SDO=0;
	CBI  0x1B,3
; 0000 0095         }
_0x20:
; 0000 0096         SI_NSCK=1;
	CALL SUBOPT_0x5
; 0000 0097         delay_us(2);
; 0000 0098         SI_NSCK=0;
; 0000 0099         delay_us(1);
; 0000 009A         regAddr=regAddr<<1;
	CALL SUBOPT_0x3
	LSL  R30
	ROL  R31
	STD  Y+2,R30
; 0000 009B     }
	SUBI R17,-1
	RJMP _0x1B
_0x1C:
; 0000 009C     for(i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x28:
	CPI  R17,8
	BRSH _0x29
; 0000 009D     {
; 0000 009E         if(regVol&0x80)
	LDD  R30,Y+1
	LDI  R31,0
	ANDI R30,LOW(0x80)
	BREQ _0x2A
; 0000 009F         {
; 0000 00A0             SI_SDO=1;
	SBI  0x1B,3
; 0000 00A1         }
; 0000 00A2         else
	RJMP _0x2D
_0x2A:
; 0000 00A3         {
; 0000 00A4             SI_SDO=0;
	CBI  0x1B,3
; 0000 00A5         }
_0x2D:
; 0000 00A6         SI_NSCK=1;
	CALL SUBOPT_0x5
; 0000 00A7         delay_us(2);
; 0000 00A8         SI_NSCK=0;
; 0000 00A9         delay_us(1);
; 0000 00AA         regVol=regVol<<1;
	LDD  R30,Y+1
	LDI  R31,0
	LSL  R30
	ROL  R31
	STD  Y+1,R30
; 0000 00AB     }
	SUBI R17,-1
	RJMP _0x28
_0x29:
; 0000 00AC 	delay_us(2);
	__DELAY_USB 7
; 0000 00AD 	SI_NSEL=1;
	SBI  0x1B,1
; 0000 00AE }
	LDD  R17,Y+0
	RJMP _0x20A0002
;
;
;
;
;unsigned char Si4432_Read_Register(unsigned char regAddr)
; 0000 00B4 {
_Si4432_Read_Register:
; 0000 00B5     unsigned char i;
; 0000 00B6 	unsigned char Result=0;
; 0000 00B7 	regAddr&=0x7f;
	ST   -Y,R17
	ST   -Y,R16
;	regAddr -> Y+2
;	i -> R17
;	Result -> R16
	LDI  R16,0
	CALL SUBOPT_0x3
	ANDI R30,LOW(0x7F)
	ANDI R31,HIGH(0x7F)
	CALL SUBOPT_0x4
; 0000 00B8 
; 0000 00B9     SI_NSEL=0;
; 0000 00BA 	delay_us(2);
; 0000 00BB     for(i=0;i<8;i++)
_0x39:
	CPI  R17,8
	BRSH _0x3A
; 0000 00BC     {
; 0000 00BD         if(regAddr&0x80)
	CALL SUBOPT_0x3
	ANDI R30,LOW(0x80)
	BREQ _0x3B
; 0000 00BE         {
; 0000 00BF             SI_SDO=1;
	SBI  0x1B,3
; 0000 00C0         }
; 0000 00C1         else
	RJMP _0x3E
_0x3B:
; 0000 00C2         {
; 0000 00C3             SI_SDO=0;
	CBI  0x1B,3
; 0000 00C4         }
_0x3E:
; 0000 00C5         SI_NSCK=1;
	CALL SUBOPT_0x5
; 0000 00C6         delay_us(2);
; 0000 00C7         SI_NSCK=0;
; 0000 00C8         delay_us(1);
; 0000 00C9         regAddr=regAddr<<1;
	CALL SUBOPT_0x3
	LSL  R30
	ROL  R31
	STD  Y+2,R30
; 0000 00CA     }
	SUBI R17,-1
	RJMP _0x39
_0x3A:
; 0000 00CB     for(i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x46:
	CPI  R17,8
	BRSH _0x47
; 0000 00CC     {
; 0000 00CD         Result=Result<<1;
	CALL SUBOPT_0x6
	MOVW R30,R26
	LSL  R30
	ROL  R31
	MOV  R16,R30
; 0000 00CE   	 	SI_NSCK=1;
	SBI  0x1B,2
; 0000 00CF   	 	delay_us(1);
	__DELAY_USB 4
; 0000 00D0         if(SI_SDI)
	SBIS 0x19,4
	RJMP _0x4A
; 0000 00D1         {
; 0000 00D2             Result|=0x01;
	CALL SUBOPT_0x6
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	OR   R30,R26
	MOV  R16,R30
; 0000 00D3         }
; 0000 00D4         SI_NSCK=0;
_0x4A:
	CBI  0x1B,2
; 0000 00D5   	 	delay_us(1);
	__DELAY_USB 4
; 0000 00D6     }
	SUBI R17,-1
	RJMP _0x46
_0x47:
; 0000 00D7   	delay_us(2);
	__DELAY_USB 7
; 0000 00D8 	SI_NSEL = 1;
	SBI  0x1B,1
; 0000 00D9     return Result;
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20A0002:
	ADIW R28,3
	RET
; 0000 00DA }
;
;
;void Si4432_Send_Data(unsigned char *buf,unsigned char len)
; 0000 00DE {
_Si4432_Send_Data:
; 0000 00DF     unsigned char i=0;
; 0000 00E0 
; 0000 00E1     //ý
; 0000 00E2     Si4432_Write_Register(0x07,0x01);
	ST   -Y,R17
;	*buf -> Y+2
;	len -> Y+1
;	i -> R17
	LDI  R17,0
	CALL SUBOPT_0x7
; 0000 00E3 
; 0000 00E4     //ݰ
; 0000 00E5     Si4432_Write_Register(0x3E,len);
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 00E6 
; 0000 00E7     //ݰ͵FIFO
; 0000 00E8     for(i=0;i<len;i++)
	LDI  R17,LOW(0)
_0x50:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x51
; 0000 00E9     {
; 0000 00EA         Si4432_Write_Register(0x7F,buf[i]);
	LDI  R30,LOW(127)
	ST   -Y,R30
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 00EB     }
	SUBI R17,-1
	RJMP _0x50
_0x51:
; 0000 00EC 
; 0000 00ED     //رжϣʹжֻ.ָʾ
; 0000 00EE     Si4432_Write_Register(0x05,0x04);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(4)
	CALL SUBOPT_0x8
; 0000 00EF     Si4432_Write_Register(0x06,0x00);
; 0000 00F0 
; 0000 00F1 
; 0000 00F2     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 00F3     Si4432_Read_Register(0x03);
; 0000 00F4     Si4432_Read_Register(0x04);
; 0000 00F5 
; 0000 00F6     //ʹ  ߵγݰԶ͡
; 0000 00F7     Si4432_Write_Register(0x07,0x09);
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 00F8 
; 0000 00F9     //ȴжϷݰ
; 0000 00FA     while(SI_NIRQ==1);
_0x52:
	CALL SUBOPT_0x9
	BREQ _0x52
; 0000 00FB 
; 0000 00FC 
; 0000 00FD     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 00FE     Si4432_Read_Register(0x03);
	CALL SUBOPT_0xA
; 0000 00FF     Si4432_Read_Register(0x04);
	CALL SUBOPT_0xB
; 0000 0100 
; 0000 0101 
; 0000 0102     //Ϊģʽ
; 0000 0103     //ʹж
; 0000 0104     // a) ӽӵݰ
; 0000 0105     // b) յݰCRC
; 0000 0106     Si4432_Write_Register(0x05,0x03);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(3)
	CALL SUBOPT_0x8
; 0000 0107     Si4432_Write_Register(0x06,0x00);
; 0000 0108 
; 0000 0109     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 010A     Si4432_Read_Register(0x03);
; 0000 010B     Si4432_Read_Register(0x04);
; 0000 010C 
; 0000 010D     //ʹܽ
; 0000 010E     Si4432_Write_Register(0x07,0x05);
	CALL SUBOPT_0xC
; 0000 010F }
	LDD  R17,Y+0
	ADIW R28,4
	RET
;
;
;unsigned char Si4432_Rev_Data(unsigned char *revBuf)
; 0000 0113 {
; 0000 0114     unsigned char i=0;
; 0000 0115     unsigned char len=0;
; 0000 0116     unsigned char ItStatus1=0;
; 0000 0117     unsigned char ItStatus2=0;
; 0000 0118     unsigned long timerOut=0x3fff;
; 0000 0119     while(timerOut!=0)
;	*revBuf -> Y+8
;	i -> R17
;	len -> R16
;	ItStatus1 -> R19
;	ItStatus2 -> R18
;	timerOut -> Y+4
; 0000 011A     {
; 0000 011B         timerOut--;
; 0000 011C         if(SI_NIRQ==0)
; 0000 011D         {
; 0000 011E             //ý
; 0000 011F             Si4432_Write_Register(0x07,0x01);
; 0000 0120 
; 0000 0121             //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 0122             ItStatus1=Si4432_Read_Register(0x03);
; 0000 0123             ItStatus2=Si4432_Read_Register(0x04);
; 0000 0124 
; 0000 0125             //CRCжϷ
; 0000 0126             if((ItStatus1&0x01)== 0x01)
; 0000 0127             {
; 0000 0128                 //RX FIFO
; 0000 0129                 Si4432_Write_Register(0x08,0x02);
; 0000 012A                 Si4432_Write_Register(0x08,0x00);
; 0000 012B             }
; 0000 012C 
; 0000 012D 			//յݰж
; 0000 012E             if((ItStatus1&0x02)==0x02)
; 0000 012F             {
; 0000 0130                 //ȡյЧغɵĳ
; 0000 0131                 len=Si4432_Read_Register(0x4B);	//read the Received Packet Length register
; 0000 0132 
; 0000 0133                 //ȡreeivedЧغɴRX FIFO
; 0000 0134                 for(i=0;i<len;i++)
; 0000 0135                 {
; 0000 0136                     revBuf[i]=Si4432_Read_Register(0x7F);	//read the FIFO Access register
; 0000 0137                 }
; 0000 0138                 UartSendBuf(revBuf,len);
; 0000 0139             }
; 0000 013A 
; 0000 013B             //RX FIFO
; 0000 013C             Si4432_Write_Register(0x08,0x02);
; 0000 013D             Si4432_Write_Register(0x08,0x00);
; 0000 013E 
; 0000 013F             //ٴý
; 0000 0140             Si4432_Write_Register(0x07,0x05);
; 0000 0141         }
; 0000 0142     }
; 0000 0143     return len;
; 0000 0144 }
;
;
;unsigned char Si4432_Get_Data(unsigned char *revBuf)
; 0000 0148 {
_Si4432_Get_Data:
; 0000 0149     unsigned char i=0;
; 0000 014A     unsigned char len=0;
; 0000 014B     unsigned char ItStatus1=0;
; 0000 014C     unsigned char ItStatus2=0;
; 0000 014D 
; 0000 014E 
; 0000 014F     //ý
; 0000 0150     Si4432_Write_Register(0x07,0x01);
	CALL __SAVELOCR4
;	*revBuf -> Y+4
;	i -> R17
;	len -> R16
;	ItStatus1 -> R19
;	ItStatus2 -> R18
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R18,0
	CALL SUBOPT_0x7
; 0000 0151 
; 0000 0152     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 0153     ItStatus1=Si4432_Read_Register(0x03);
	CALL SUBOPT_0xA
	MOV  R19,R30
; 0000 0154     ItStatus2=Si4432_Read_Register(0x04);
	CALL SUBOPT_0xB
	MOV  R18,R30
; 0000 0155 
; 0000 0156     //CRCжϷ
; 0000 0157     if((ItStatus1&0x01)== 0x01)
	MOV  R30,R19
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x1)
	BRNE _0x5E
; 0000 0158     {
; 0000 0159         //RX FIFO
; 0000 015A         Si4432_Write_Register(0x08,0x02);
	CALL SUBOPT_0xE
; 0000 015B         Si4432_Write_Register(0x08,0x00);
; 0000 015C     }
; 0000 015D 
; 0000 015E     //յݰж
; 0000 015F     if((ItStatus1&0x02)==0x02)
_0x5E:
	MOV  R26,R19
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,2
	BRNE _0x5F
; 0000 0160     {
; 0000 0161         //ȡյЧغɵĳ
; 0000 0162         len=Si4432_Read_Register(0x4B);	//read the Received Packet Length register
	LDI  R30,LOW(75)
	ST   -Y,R30
	RCALL _Si4432_Read_Register
	MOV  R16,R30
; 0000 0163 
; 0000 0164         //ȡreeivedЧغɴRX FIFO
; 0000 0165         for(i=0;i<len;i++)
	LDI  R17,LOW(0)
_0x61:
	CP   R17,R16
	BRSH _0x62
; 0000 0166         {
; 0000 0167             revBuf[i]=Si4432_Read_Register(0x7F);	//read the FIFO Access register
	MOV  R30,R17
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(127)
	ST   -Y,R30
	RCALL _Si4432_Read_Register
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0168         }
	SUBI R17,-1
	RJMP _0x61
_0x62:
; 0000 0169         UartSendBuf(revBuf,len);
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	CALL __CWD1
	CALL __PUTPARD1
	RCALL _UartSendBuf
; 0000 016A     }
; 0000 016B 
; 0000 016C     //RX FIFO
; 0000 016D     Si4432_Write_Register(0x08,0x02);
_0x5F:
	CALL SUBOPT_0xE
; 0000 016E     Si4432_Write_Register(0x08,0x00);
; 0000 016F 
; 0000 0170     //ٴý
; 0000 0171     Si4432_Write_Register(0x07,0x05);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL SUBOPT_0xC
; 0000 0172 
; 0000 0173     return len;
	MOV  R30,R16
	CALL __LOADLOCR4
	ADIW R28,6
	RET
; 0000 0174 }
;
;void Si4432_Init(void)
; 0000 0177 {
_Si4432_Init:
; 0000 0178     //ͨPWRDNŴSI4432ڲԴ
; 0000 0179     SI_SND=0;
	CBI  0x1B,0
; 0000 017A 
; 0000 017B 
; 0000 017C     //ٵȴ15beforyκγʼSPI͵SI4432
; 0000 017D     //ȴϵ縴λ
; 0000 017E     delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x2
; 0000 017F 
; 0000 0180     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 0181     Si4432_Read_Register(0x03);
	CALL SUBOPT_0xA
; 0000 0182     Si4432_Read_Register(0x04);
	CALL SUBOPT_0xB
; 0000 0183 
; 0000 0184     //λоƬ
; 0000 0185     Si4432_Write_Register(0x07,0x80);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 0186 
; 0000 0187     //ȴPORжϣNIRQΪߣ
; 0000 0188     while(SI_NIRQ==1);
_0x65:
	CALL SUBOPT_0x9
	BREQ _0x65
; 0000 0189 
; 0000 018A     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 018B     Si4432_Read_Register(0x03);
	CALL SUBOPT_0xA
; 0000 018C     Si4432_Read_Register(0x04);                                                 //read the Interrupt Status2 register
	CALL SUBOPT_0xB
; 0000 018D 
; 0000 018E     //ȴоƬжϣNIRQΪߵƽ
; 0000 018F     while(SI_NIRQ==1);
_0x68:
	CALL SUBOPT_0x9
	BREQ _0x68
; 0000 0190 
; 0000 0191     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 0192     Si4432_Read_Register(0x03);
	CALL SUBOPT_0xA
; 0000 0193     Si4432_Read_Register(0x04);
	CALL SUBOPT_0xB
; 0000 0194 
; 0000 0195     //
; 0000 0196     //Ƶ 915 MHz
; 0000 0197     //Si4432_Write_Register(0x75,0x75);
; 0000 0198 	//Si4432_Write_Register(0x76,0xBB);
; 0000 0199 	//Si4432_Write_Register(0x77,0x80);
; 0000 019A  	//д0x80زFrequency0Ĵ
; 0000 019B 	Si4432_Write_Register(0x75,0x53);
	LDI  R30,LOW(117)
	ST   -Y,R30
	LDI  R30,LOW(83)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 019C 	Si4432_Write_Register(0x76,0x64);
	LDI  R30,LOW(118)
	ST   -Y,R30
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 019D 	Si4432_Write_Register(0x77,0x00);
	LDI  R30,LOW(119)
	CALL SUBOPT_0xF
; 0000 019E 
; 0000 019F 	//TX (9.6kbps)
; 0000 01A0 	//Si4432_Write_Register(0x6E,0x4E);
; 0000 01A1 	//Si4432_Write_Register(0x6F,0xA5);
; 0000 01A2 	//Si4432_Write_Register(0x70,0x2C);
; 0000 01A3 
; 0000 01A4 	//TX (1.2kbps)
; 0000 01A5 	Si4432_Write_Register(0x2a,0x14);
	CALL SUBOPT_0x10
; 0000 01A6 	Si4432_Write_Register(0x6E,0x09);
	LDI  R30,LOW(110)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01A7 	Si4432_Write_Register(0x6F,0xd5);
	LDI  R30,LOW(111)
	ST   -Y,R30
	LDI  R30,LOW(213)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01A8 	Si4432_Write_Register(0x70,0x2C);
	LDI  R30,LOW(112)
	ST   -Y,R30
	LDI  R30,LOW(44)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01A9 
; 0000 01AA 	//TXƫĴ (+-45kHz)
; 0000 01AB 	//Si4432_Write_Register(0x72,0x48);	//(9.6kbps)
; 0000 01AC     Si4432_Write_Register(0x72,0x38);	//(1.2kbps)
	LDI  R30,LOW(114)
	ST   -Y,R30
	LDI  R30,LOW(56)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01AD 
; 0000 01AE 	/*EXELõƽ: 9.6 kbps, deviation: 45 kHz, channel filter BW: 102.2 kHz*/
; 0000 01AF 	Si4432_Write_Register(0x1C,0x1b);		//write 0x1E to the IF Filter Bandwidth register
	LDI  R30,LOW(28)
	ST   -Y,R30
	LDI  R30,LOW(27)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B0 	Si4432_Write_Register(0x20,0x83);		//write 0xD0 to the Clock Recovery Oversampling Ratio register
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(131)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B1 	Si4432_Write_Register(0x21,0xc0);		//write 0x00 to the Clock Recovery Offset 2 register
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(192)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B2 	Si4432_Write_Register(0x22,0x13);		//write 0x9D to the Clock Recovery Offset 1 register
	LDI  R30,LOW(34)
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B3 	Si4432_Write_Register(0x23,0xa9);		//write 0x49 to the Clock Recovery Offset 0 register
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R30,LOW(169)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B4 	Si4432_Write_Register(0x24,0x00);		//write 0x00 to the Clock Recovery Timing Loop Gain 1 register
	LDI  R30,LOW(36)
	CALL SUBOPT_0xF
; 0000 01B5 	Si4432_Write_Register(0x25,0x03);		//write 0x24 to the Clock Recovery Timing Loop Gain 0 register
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B6 	Si4432_Write_Register(0x1D,0x40);		//write 0x40 to the AFC Loop Gearshift Override register
	LDI  R30,LOW(29)
	ST   -Y,R30
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B7 	Si4432_Write_Register(0x1E,0x0A);		//write 0x0A to the AFC Timing Control register
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01B8 	Si4432_Write_Register(0x2A,0x14);		//write 0x20 to the AFC Limiter register
	CALL SUBOPT_0x10
; 0000 01B9 
; 0000 01BA 	//ݰĽṹ͵
; 0000 01BB 	//ǰ볤 5bytes
; 0000 01BC 	Si4432_Write_Register(0x34, 0x0A);	//write 0x0A to the Preamble Length register
	LDI  R30,LOW(52)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01BD 
; 0000 01BE 	//ǰֵ 20bits
; 0000 01BF 	Si4432_Write_Register(0x35,0x2A); 	//write 0x2A to the Preamble Detection Control  register
	LDI  R30,LOW(53)
	ST   -Y,R30
	LDI  R30,LOW(42)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01C0 
; 0000 01C1 	//ͷֽ;ÿɱķ鳤ȣЧصĳɶ
; 0000 01C2 	//յݰȵݰ;ֽ֣ͬڳ
; 0000 01C3 	Si4432_Write_Register(0x33,0x02);	//write 0x02 to the Header Control2 register
	LDI  R30,LOW(51)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01C4 
; 0000 01C5 	//ͬ 0x2DD4
; 0000 01C6 	Si4432_Write_Register(0x36,0x2D);   //write 0x2D to the Sync Word 3 register
	LDI  R30,LOW(54)
	ST   -Y,R30
	LDI  R30,LOW(45)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01C7 	Si4432_Write_Register(0x37,0xD4);	//write 0xD4 to the Sync Word 2 register
	LDI  R30,LOW(55)
	ST   -Y,R30
	LDI  R30,LOW(212)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01C8 
; 0000 01C9 	//TXRXݰCRC-16IBMļ
; 0000 01CA 	Si4432_Write_Register(0x30,0x8D);	//write 0x8D to the Data Access Control register
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(141)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01CB 
; 0000 01CC 	//ýͷ
; 0000 01CD     Si4432_Write_Register(0x32,0x00 );	//write 0x00 to the Header Control1 register
	LDI  R30,LOW(50)
	CALL SUBOPT_0xF
; 0000 01CE 
; 0000 01CF 	//FIFOģʽGFSK
; 0000 01D0 	Si4432_Write_Register(0x71,0x63);	//write 0x63 to the Modulation Mode Control 2 register
	LDI  R30,LOW(113)
	ST   -Y,R30
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01D1 
; 0000 01D2 	//øGPIOĸRF
; 0000 01D3     //Si4432_Write_Register(0x0C,0x12);	//write 0x12 to the GPIO1 Configuration(set the TX state)
; 0000 01D4 	//Si4432_Write_Register(0x0b,0x15);	//write 0x15 to the GPIO2 Configuration(set the RX state)
; 0000 01D5 	Si4432_Write_Register(0x0C,0x15);	//write 0x15 to the GPIO1 Configuration(set the rX state)
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01D6 	Si4432_Write_Register(0x0b,0x12);	//write 0x12 to the GPIO0Configuration(set the tX state)
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01D7 
; 0000 01D8 	//÷ĬSi443xĴ
; 0000 01D9 	//set  cap. bank
; 0000 01DA 	Si4432_Write_Register(0x09,0xD7);	//write 0xD7 to the Crystal Oscillator Load Capacitance register
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(215)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01DB 
; 0000 01DC 	// Set AGC Override1 Register
; 0000 01DD 	Si4432_Write_Register(0x69,0x60);	//write 0x60 to the AGC Override1 register
	LDI  R30,LOW(105)
	ST   -Y,R30
	LDI  R30,LOW(96)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01DE 
; 0000 01DF 	//TX20dBm
; 0000 01E0 	//Si4432_Write_Register(0x6d,0x1f);
; 0000 01E1 	Si4432_Write_Register(0x6d,0x1e);
	LDI  R30,LOW(109)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01E2 
; 0000 01E3 	//ʹ
; 0000 01E4 	Si4432_Write_Register(0x07,0x05);//write 0x05 to the Operating Function Control 1 register
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL SUBOPT_0xC
; 0000 01E5 
; 0000 01E6     //Ϊģʽ
; 0000 01E7     //ʹж
; 0000 01E8     // a) ӽӵݰ
; 0000 01E9     // b) յݰCRC
; 0000 01EA     Si4432_Write_Register(0x05,0x03);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(3)
	CALL SUBOPT_0x8
; 0000 01EB     Si4432_Write_Register(0x06,0x00);
; 0000 01EC 
; 0000 01ED     //ȡж״̬regsitersйжnIRQţʹNIRQߵƽ
; 0000 01EE     Si4432_Read_Register(0x03);
; 0000 01EF     Si4432_Read_Register(0x04);
; 0000 01F0 
; 0000 01F1 
; 0000 01F2     //ʹ
; 0000 01F3 	Si4432_Write_Register(0x07,0x05);//write 0x05 to the Operating Function Control 1 register
	CALL SUBOPT_0xC
; 0000 01F4 
; 0000 01F5     Si4432_Write_Register(0x0d,0xf4);
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(244)
	ST   -Y,R30
	RCALL _Si4432_Write_Register
; 0000 01F6 }
	RET
;
;
;
;void Read_Reg_Test(void)
; 0000 01FB {
_Read_Reg_Test:
; 0000 01FC     unsigned char buf[32]={0};
; 0000 01FD     unsigned char dat=0;
; 0000 01FE 
; 0000 01FF 	dat=Si4432_Read_Register(0x75);
	SBIW R28,32
	LDI  R24,32
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x6B*2)
	LDI  R31,HIGH(_0x6B*2)
	CALL __INITLOCB
	ST   -Y,R17
;	buf -> Y+1
;	dat -> R17
	LDI  R17,0
	LDI  R30,LOW(117)
	CALL SUBOPT_0x11
; 0000 0200     sprintf(buf,"Si4432_Read_Register(0x75)=%02x\r\n",dat);
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x12
; 0000 0201     UartSendStr(buf);
; 0000 0202 
; 0000 0203 
; 0000 0204 	dat=Si4432_Read_Register(0x76);
	LDI  R30,LOW(118)
	CALL SUBOPT_0x11
; 0000 0205     sprintf(buf,"Si4432_Read_Register(0x76)=%02x\r\n",dat);
	__POINTW1FN _0x0,34
	CALL SUBOPT_0x12
; 0000 0206     UartSendStr(buf);
; 0000 0207 
; 0000 0208 
; 0000 0209 	dat=Si4432_Read_Register(0x77);
	LDI  R30,LOW(119)
	CALL SUBOPT_0x11
; 0000 020A     sprintf(buf,"Si4432_Read_Register(0x77)=%02x\r\n",dat);
	__POINTW1FN _0x0,68
	CALL SUBOPT_0x12
; 0000 020B     UartSendStr(buf);
; 0000 020C }
	LDD  R17,Y+0
	ADIW R28,33
	RET
;
;
;
;
;void main(void)
; 0000 0212 {
_main:
; 0000 0213     char *str="start...\r\n";
; 0000 0214     unsigned char buf[128]={0};
; 0000 0215     delay_ms(100);
	SBIW R28,63
	SBIW R28,63
	SBIW R28,2
	LDI  R24,128
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x6D*2)
	LDI  R31,HIGH(_0x6D*2)
	CALL __INITLOCB
;	*str -> R16,R17
;	buf -> Y+0
	__POINTWRMN 16,17,_0x6C,0
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x2
; 0000 0216     Io_Init();
	RCALL _Io_Init
; 0000 0217     Uart_Init();
	RCALL _Uart_Init
; 0000 0218     Ext_Inter_Init();
	RCALL _Ext_Inter_Init
; 0000 0219     Si4432_Init();
	RCALL _Si4432_Init
; 0000 021A     #asm("sei")
	sei
; 0000 021B     UartSendStr(str);
	ST   -Y,R17
	ST   -Y,R16
	RCALL _UartSendStr
; 0000 021C     Read_Reg_Test();
	RCALL _Read_Reg_Test
; 0000 021D     while (1)
_0x6E:
; 0000 021E     {
; 0000 021F         Key_Scan();
	RCALL _Key_Scan
; 0000 0220         if(SiRevIntFlag)
	TST  R5
	BREQ _0x71
; 0000 0221         {
; 0000 0222             SiRevIntFlag=0;
	CLR  R5
; 0000 0223             Si4432_Get_Data(buf);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Si4432_Get_Data
; 0000 0224         }
; 0000 0225         if(SiSendFlag)
_0x71:
	TST  R4
	BREQ _0x72
; 0000 0226         {
; 0000 0227             Si4432_Send_Data(RevUartBuf,revCnt);
	LDI  R30,LOW(_RevUartBuf)
	LDI  R31,HIGH(_RevUartBuf)
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_revCnt
	ST   -Y,R30
	RCALL _Si4432_Send_Data
; 0000 0228             revCnt=0;
	CALL SUBOPT_0x1
; 0000 0229             SiSendFlag=0;
	CLR  R4
; 0000 022A         }
; 0000 022B         //Si4432_Rev_Data(buf);
; 0000 022C     };
_0x72:
	RJMP _0x6E
; 0000 022D }
_0x73:
	RJMP _0x73

	.DSEG
_0x6C:
	.BYTE 0xB
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
_0x20A0001:
	ADIW R28,1
	RET
__put_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2000012:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2000013:
	RJMP _0x2000014
_0x2000010:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x2000014:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x2000015:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000017
	MOV  R30,R17
	LDI  R31,0
	SBIW R30,0
	BRNE _0x200001B
	CPI  R18,37
	BRNE _0x200001C
	LDI  R17,LOW(1)
	RJMP _0x200001D
_0x200001C:
	CALL SUBOPT_0x13
_0x200001D:
	RJMP _0x200001A
_0x200001B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x200001E
	CPI  R18,37
	BRNE _0x200001F
	CALL SUBOPT_0x13
	RJMP _0x20000BC
_0x200001F:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000020
	LDI  R16,LOW(1)
	RJMP _0x200001A
_0x2000020:
	CPI  R18,43
	BRNE _0x2000021
	LDI  R20,LOW(43)
	RJMP _0x200001A
_0x2000021:
	CPI  R18,32
	BRNE _0x2000022
	LDI  R20,LOW(32)
	RJMP _0x200001A
_0x2000022:
	RJMP _0x2000023
_0x200001E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2000024
_0x2000023:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000025
	CALL SUBOPT_0x6
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x200001A
_0x2000025:
	RJMP _0x2000026
_0x2000024:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x200001A
_0x2000026:
	CPI  R18,48
	BRLO _0x2000029
	CPI  R18,58
	BRLO _0x200002A
_0x2000029:
	RJMP _0x2000028
_0x200002A:
	MOV  R26,R21
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	MULS R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R22,R21
	CLR  R23
	MOV  R26,R18
	LDI  R27,0
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R30,R26
	MOV  R21,R30
	RJMP _0x200001A
_0x2000028:
	CALL SUBOPT_0x14
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x200002E
	CALL SUBOPT_0x15
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x16
	RJMP _0x200002F
_0x200002E:
	CPI  R30,LOW(0x73)
	LDI  R26,HIGH(0x73)
	CPC  R31,R26
	BRNE _0x2000031
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000032
_0x2000031:
	CPI  R30,LOW(0x70)
	LDI  R26,HIGH(0x70)
	CPC  R31,R26
	BRNE _0x2000034
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
	CALL _strlenf
	MOV  R17,R30
	CALL SUBOPT_0x6
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	OR   R30,R26
	MOV  R16,R30
_0x2000032:
	CALL SUBOPT_0x6
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	OR   R30,R26
	MOV  R16,R30
	CALL SUBOPT_0x6
	LDI  R30,LOW(65407)
	LDI  R31,HIGH(65407)
	AND  R30,R26
	MOV  R16,R30
	LDI  R19,LOW(0)
	RJMP _0x2000035
_0x2000034:
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BREQ _0x2000038
	CPI  R30,LOW(0x69)
	LDI  R26,HIGH(0x69)
	CPC  R31,R26
	BRNE _0x2000039
_0x2000038:
	CALL SUBOPT_0x6
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x200003A
_0x2000039:
	CPI  R30,LOW(0x75)
	LDI  R26,HIGH(0x75)
	CPC  R31,R26
	BRNE _0x200003B
_0x200003A:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003C
_0x200003B:
	CPI  R30,LOW(0x58)
	LDI  R26,HIGH(0x58)
	CPC  R31,R26
	BRNE _0x200003E
	CALL SUBOPT_0x6
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x200003F
_0x200003E:
	CPI  R30,LOW(0x78)
	LDI  R26,HIGH(0x78)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2000070
_0x200003F:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003C:
	CALL SUBOPT_0x6
	CALL SUBOPT_0x18
	BREQ _0x2000041
	CALL SUBOPT_0x15
	CALL SUBOPT_0x19
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000042
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000042:
	CPI  R20,0
	BREQ _0x2000043
	SUBI R17,-LOW(1)
	RJMP _0x2000044
_0x2000043:
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1A
_0x2000044:
	RJMP _0x2000045
_0x2000041:
	CALL SUBOPT_0x15
	CALL SUBOPT_0x19
_0x2000045:
_0x2000035:
	MOV  R30,R16
	CALL SUBOPT_0xD
	BRNE _0x2000046
_0x2000047:
	CP   R17,R21
	BRSH _0x2000049
	CALL SUBOPT_0x6
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200004A
	CALL SUBOPT_0x6
	CALL SUBOPT_0x18
	BREQ _0x200004B
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1A
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004C
_0x200004B:
	LDI  R18,LOW(48)
_0x200004C:
	RJMP _0x200004D
_0x200004A:
	LDI  R18,LOW(32)
_0x200004D:
	CALL SUBOPT_0x13
	SUBI R21,LOW(1)
	RJMP _0x2000047
_0x2000049:
_0x2000046:
	MOV  R19,R17
	CALL SUBOPT_0x6
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200004E
_0x200004F:
	CPI  R19,0
	BREQ _0x2000051
	CALL SUBOPT_0x6
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000052
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x20000BD
_0x2000052:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x20000BD:
	ST   -Y,R30
	CALL SUBOPT_0x16
	CPI  R21,0
	BREQ _0x2000054
	SUBI R21,LOW(1)
_0x2000054:
	SUBI R19,LOW(1)
	RJMP _0x200004F
_0x2000051:
	RJMP _0x2000055
_0x200004E:
_0x2000057:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2000059:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005B
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2000059
_0x200005B:
	CPI  R18,58
	BRLO _0x200005C
	CALL SUBOPT_0x6
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200005D
	CALL SUBOPT_0x14
	ADIW R30,7
	RJMP _0x20000BE
_0x200005D:
	CALL SUBOPT_0x14
	ADIW R30,39
_0x20000BE:
	MOV  R18,R30
_0x200005C:
	CALL SUBOPT_0x6
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE _0x2000060
	CPI  R18,49
	BRSH _0x2000062
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000061
_0x2000062:
	RJMP _0x20000BF
_0x2000061:
	CP   R21,R19
	BRLO _0x2000066
	MOV  R30,R16
	CALL SUBOPT_0xD
	BREQ _0x2000067
_0x2000066:
	RJMP _0x2000065
_0x2000067:
	LDI  R18,LOW(32)
	CALL SUBOPT_0x6
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000068
	LDI  R18,LOW(48)
_0x20000BF:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	OR   R30,R26
	MOV  R16,R30
	CALL SUBOPT_0x6
	CALL SUBOPT_0x18
	BREQ _0x2000069
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1A
	ST   -Y,R20
	CALL SUBOPT_0x16
	CPI  R21,0
	BREQ _0x200006A
	SUBI R21,LOW(1)
_0x200006A:
_0x2000069:
_0x2000068:
_0x2000060:
	CALL SUBOPT_0x13
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x2000065:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000058
	RJMP _0x2000057
_0x2000058:
_0x2000055:
	MOV  R30,R16
	CALL SUBOPT_0xD
	BREQ _0x200006C
_0x200006D:
	CPI  R21,0
	BREQ _0x200006F
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x16
	RJMP _0x200006D
_0x200006F:
_0x200006C:
_0x2000070:
_0x200002F:
_0x20000BC:
	LDI  R17,LOW(0)
_0x200001A:
	RJMP _0x2000015
_0x2000017:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.CSEG

	.DSEG
_RevUartBuf:
	.BYTE 0x80
_revCnt:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4
_p_S1020024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDS  R30,_revCnt
	LDS  R31,_revCnt+1
	LDS  R22,_revCnt+2
	LDS  R23,_revCnt+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	__GETD1N 0x0
	STS  _revCnt,R30
	STS  _revCnt+1,R31
	STS  _revCnt+2,R22
	STS  _revCnt+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	LDD  R30,Y+2
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	STD  Y+2,R30
	CBI  0x1B,1
	__DELAY_USB 7
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5:
	SBI  0x1B,2
	__DELAY_USB 7
	CBI  0x1B,2
	__DELAY_USB 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x6:
	MOV  R26,R16
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _Si4432_Write_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x8:
	ST   -Y,R30
	CALL _Si4432_Write_Register
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _Si4432_Write_Register
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _Si4432_Read_Register
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _Si4432_Read_Register
	LDI  R30,LOW(7)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R26,0
	SBIC 0x10,2
	LDI  R26,1
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _Si4432_Read_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(4)
	ST   -Y,R30
	JMP  _Si4432_Read_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(5)
	ST   -Y,R30
	JMP  _Si4432_Write_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDI  R31,0
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _Si4432_Write_Register
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _Si4432_Write_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _Si4432_Write_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	JMP  _Si4432_Write_Register

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	ST   -Y,R30
	CALL _Si4432_Read_Register
	MOV  R17,R30
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x12:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	JMP  _UartSendStr

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x13:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	MOV  R30,R18
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x15:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x16:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x17:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	AND  R30,R26
	MOV  R16,R30
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xACD
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
